unit hiArgParser;

interface

uses Kol,Share,Debug,Windows;

type
  THIArgParser = class(TDebug)
   private
    Args:PStrList;
    ArgArray:PArray;
    procedure SetArgs(arg:string);
    function ArgRead(Var Item:TData; var Val:TData):boolean;
    function ArgCount:integer;
    public
    //ArgArray:THI_Event;
    _prop_Prefix:string;
    
    constructor Create;
    destructor Destroy; override;
    procedure _var_Args(var _Data:TData; Index:word);
    property _prop_Args:string write SetArgs; 
  end;

implementation

function THIArgParser.ArgRead;
var
  ind:integer;
begin
  ind := ToIntIndex(Item);
  if(ind >= 0 )and(ind < ParamCount)then
    dtString(Val,ParamStr(ind+1))
  else dtNull(Val);
  Result := _IsStr(Val);
end;

function THIArgParser.ArgCount;
begin
   Result := ParamCount;
end;

constructor THIArgParser.Create;
begin
   inherited;
   ArgArray := CreateArray(nil,ArgRead,ArgCount,nil);
end;

destructor THIArgParser.Destroy;
begin
   Args.Free;
   if ArgArray <> nil then dispose(ArgArray);
   inherited;
end;

procedure THIArgParser.SetArgs;
begin
  Args := NewStrList;
  Args.text := CharLower(@arg[1]); 
end;

procedure THIArgParser._var_Args;
var i:integer;idata:TData;swich:TData;switch:string;processing:string;
begin
  processing := '';
  for i:= 0 to ArgArray._Count-1 do
  begin
    idata := _DoData(i);
    if not ArgArray._Get(idata,swich) then exit;
    switch := ToString(swich);
    if Copy(switch,1,Length(_prop_Prefix)) = _prop_Prefix then begin
      if processing = Args.Items[Index] then begin
        dtString(_Data,switch);
        Exit;
      end;
      Delete(switch,1,Length(_prop_Prefix));
      CharLower(@switch[1]);
      if i < ArgArray._Count-1 then begin
        if Args.Items[Index] = switch then begin
          processing := switch;
        end;
      end
      else begin
	    dtString(_Data,''); //      
	    Exit;
      end
    end
    else if processing <> '' then begin
      dtString(_Data,switch); //     
      Exit;
    end;
  end;
  dtNull(_Data); //  
end;

end.
